# REQUIRED
openapi: 3.0.3

# REQUIRED
info:
  # REQUIRED
  version: 7.37-api-responses-headers # added responses -> headers to post API
  # REQUIRED
  title: Open API Cource
  # OPTIONAL
  description: 'Spec for Open API cource'
  # OPTIONAL
  contact:
    name: kaushiwould
    email: kaushiwould@gmail.com
    url: www.kaushiwould.com
  # OPTIONAL
  license:
    name: Apache 2.0
    url: https://www.apache.org/licenses/LICENSE-2.0.html

# OPTIONAL
servers: # List
# REQUIRED
- url: https://development.gigantic-server.com/v1
  description: Development server
# REQUIRED
- url: https://staging.gigantic-server.com/v1
  description: Staging server
# REQUIRED
- url: https://api.gigantic-server.com/v1
  description: Production server

# REQUIRED
paths:
  #####################################Customers
  /v1/customers:
    post:
      operationId: postCustomerV1
      tags: 
        - Customers
      summary: Creating Customer
      description: Creating a new customer.
      requestBody:
        description: "Request body for creating customer"
        content:
          application/json:
           schema:
             $ref: '#/components/schemas/Customer'
      responses:
        201:
          description: "Customer created"
          headers:
            locationOfCustomer:
              description: Get Url for Getting Customer by id.
              schema:
                type: string
                format: uri
                example: www.example.com/customers/{customerId}
      
  /v1/customers/{customerId}:
    get:
      operationId: getCustomerByIdV1 # operationId must be unique across all api, it used for code gen, its not displayed on ui 
      tags: # tags for grouping API eg- by default RestControllerName comes as tag
        - Customers
      summary: Get Customer by Id
      # description support md file syntax
      description: Get **Customer information** as per the specified id.
      parameters: 
        - name: customerId # should be same as name defined in url(path) above
          in: path # this tell its a path variable.
          description: "Unique customer identifier."
          required: true
          schema:
            type: string
            format: uuid
      responses:
        200:
          description: Foud Customer
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Customer'
                
  #####################################
  /v1/beers/{beerId}:
    get:
      operationId: getBeerByIdV1 # operationId must be unique across all api, it used for code gen, its not displayed on ui
      tags: [Beers] # tags for grouping API eg- by default RestControllerName comes as tag
      summary: Get Beer by Id
      # description support md file syntax
      description: Get **Beer information** as per the specified id.
      parameters: 
        - name: beerId # should be same as name defined in url(path) above 
          in: path # this tell its a path variable.
          description: "Unique beer identifier."
          required: true
          schema:
            type: integer
            format: int32
            default: 1
      responses:
        200:
          description: Found Beers
          content: 
            application/json:
              schema:
                $ref: '#/components/schemas/Beer'
    
# OPTIONAL
# components are reusable, its used with $ref
components: 
  schemas:
    ############################################
    Customer:
      #eg for string data type
      #type: string
      #minLength: 2
      #maxLength: 100
      
      #eg for object type
      type: object
      properties: # define json keys
        id:
          type: string
          format: uuid #special format for uuid
        firstname:
          type: string
          minLength: 2
          maxLength: 100
          example: Kaushlendra Singh
        lastname:
          type: string
          minimum: 2
          maxLength: 100
          example: Chauhan
        address:
          $ref: '#/components/schemas/Address'
    ############################################
    Address:    
      type: object
      properties:
        line1: 
          type: string
          example: MI Casa Bela
        line2:
          type: string
          example: wakad
        statecode:
          type: string
          minLength: 1
          maxLength: 100
          description: 2 letters
          # enum
          # way 1 - defining enum
          #enum:
            #- A
            #- B
            #- C
          # way 2 - defining enum
          enum: [A, B, C]
    ############################################
    ############################################
    Beer:
      type: object
      properties:
        name:
         type: string
         example: Bira
        style:
          type: string
          enum : [A, B, C, D]
        upc:
          type: string
          format: uuid
        price:
         type: number
         example: 170
        quantity:
          type: number
          example: 12
        brewery:
         $ref: '#/components/schemas/Brewery'
    ############################################
    Brewery:
      type: object
      properties:
        name:
          type: string
          example: Sahara
        location:
          type: string
          example: Wakad, Pune